-- Phrase variables
BINDING_HEADER_BANKGUI = "BankGUI v2.1";
BINDING_NAME_BANKGUITOGGLE = "Show / Hide BankGUI Window";

BANKGUIS_TO_DISPLAY = 18;
FRIENDS_FRAME_BANKGUI_HEIGHT = 16;

BANKGUI_TABNAME			= "Bank";
BANKGUI_TITLE			= "BankGUI";
BANKGUI_GUILD			= "Guild";
BANKGUI_DELETE			= "Delete";
BANKGUI_DELETES			= "Delete Items";

BANKGUI_DETAILS_OF		= "Owner |cffffffff%s|r";
BANKGUI_ITEM			= "Item name";
BANKGUI_AMOUNT			= "Amount";
BANKGUI_TYPE			= "Item Type";
BANKGUI_LEVEL			= "Item Level";
BANKGUI_INVENT			= "Inventory";
BANKGUI_EQUIP			= "Equipslot";
BANKGUI_VENDOR			= "Vendor value";

BANKGUI_GOLD_BANK = "Total Gold |cffffffff%.2f|r";
BANKGUI_GOLD_GUILD = "Gold |cffffffff%.2f|r";

BANKGUI_HELP = {
	{ BANKGUI_TITLE .." help:", 1, 0.5, 0 },
	{ " Go to Social |cffffff80(O)|r and select the Bank tab at the bottomright of the window.", 0.5, 1, 1 },
	{ " There you see a list of items that are in bags/bank/equiped on all your characters (per account, per realm).", 0.5, 1, 1 },
	{ " |cffffff80NOTE:|r Items only get added/updated to the list when you open your Bank/Tradeskill window.", 0.5, 1, 1 },
	{ " ", 1, 1, 1 },
	{ " |cffffff80/bank|r Shows / Hides the BankGUI window", 1, 1, 1 },
	{ " |cffffff80/bank help|r to show help text", 1, 1, 1 },
	{ " |cffffff80/bank update|r to update Currency, Friendlist and Glyphs", 1, 1, 1 },
	{ " |cffffff80/bank detach|r to detach the BankGUI window from the Social pane", 1, 1, 1 },
	{ " |cffffff80/bank attach|r to attach the BankGUI window to the Social pane", 1, 1, 1 },
	{ " ", 1, 1, 1 },
	{ "Hyperlink in Chat windows:", 1, 0.5, 0 },
	{ " |cffffff80Shift-Click|r Put the link text in the Filter textbox", 1, 1, 1 },
	{ " |cffffff80Alt-Click|r Put the link text in the Farm textbox", 1, 1, 1 },
}

BANKGUI_TYPE_CURRENCY  = "-8";
BANKGUI_TYPE_FRIENDS   = "-7";
BANKGUI_TYPE_GLYPHS    = "-6";
BANKGUI_TYPE_FARMS     = "-5";
BANKGUI_TYPE_TRADELINK = "-4";


BANKGUI_KEEPTRACKOF = "KeepTrackOf";
BANKGUI_KEEPGUILD   = "Guild Items";
BANKGUI_KEEPITEMS   = "Items";
BANKGUI_KEEPTRADE   = "TradeSkills";
BANKGUI_KEEPPROFS   = "Profession Links";
BANKGUI_KEEPGLYPS   = "Glyphs";
BANKGUI_KEEPFRIEND  = "Friends";
BANKGUI_KEEPCURR    = "Currency";
BANKGUI_TOOLTIPS    = "Tooltips";

BANKGUI_OPTIONS_MENU = {
	[BANKGUI_KEEPTRACKOF] = {
		BANKGUI_KEEPGUILD,
		BANKGUI_KEEPITEMS,
		BANKGUI_KEEPTRADE,
		BANKGUI_KEEPPROFS,
		BANKGUI_KEEPGLYPS,
		BANKGUI_KEEPFRIEND,
		BANKGUI_KEEPCURR,
	},
	{
		["name"] = BANKGUI_TOOLTIPS,
	},
}


-- Global variables

bank_chat = ChatFrame1;
bank_playername = nil;
bank_guildname = nil;
bank_frame_opened = false;
bank_craft_casting = false;

bank_numtab = 0;

bank_crafts = {
	["Milling"] = true,
	["Prospecting"] = true,
};

TypesIndex = 1;

Item_NoDelete = {
	["-4"] = "TradeLink",
};

BankGUI = {};

BankList = {};
BankFilter = {};

BankListPlayers = {};

BankListGuildInfo = {};

BankListItems = {};
BankListGuildItems = {};
BankListCurrency = {};
BankListFriends = {};
BankListGlyphs  = {};
BankListFarms = {};

BankListOptions = {};

BankListStock = {};

BankListFL = {};

Wisp_Data = {};



-- Function to handle onload event
function BankGUI:OnLoad()

	-- constructions
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_LOGIN");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_MONEY");
	this:RegisterEvent("PLAYER_GUILD_UPDATE");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("CHAT_MSG_SYSTEM");
	this:RegisterEvent("BANKFRAME_OPENED");
	this:RegisterEvent("BANKFRAME_CLOSED");
	this:RegisterEvent("TRADE_SKILL_SHOW");
	this:RegisterEvent("GUILDBANKFRAME_OPENED");
	this:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
	this:RegisterEvent("BAG_UPDATE");
	--this:RegisterEvent("LOOT_OPENED");
	--this:RegisterEvent("LOOT_CLOSED");
	this:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	this:RegisterAllEvents();
	bank_chat:AddMessage("|cffff8000"..BINDING_HEADER_BANKGUI .."|r loaded. Go to |cffffff80Social (O)|r and select the |cffffff80Bank|r tab on the bottom right, or type |cffffff80/bank|r.", 0.5,1,1);
	SLASH_BANK1 = "/bank";
	SlashCmdList["BANK"] = function(msg)
		BankGUI:Bank_SlashCommandHandler(msg);
	end

end


function BankGUI:AddTooltip(tooltip, itemname, ...)
	if not BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] then return end
	if BankListStock[itemname] then
		if BankListStock[itemname]["stock"] ~= nil then
			if BankListStock[itemname]["self"] ~= nil then
				tooltip:AddLine( format("|cffff8000In Stock|r |cffffffff%i (%i)|r", BankListStock[itemname]["stock"], BankListStock[itemname]["self"]) );
			else
				tooltip:AddLine( format("|cffff8000In Stock|r |cffffffff%i|r", BankListStock[itemname]["stock"]) );
			end
		end
		if BankListStock[itemname]["bagged"] ~= nil then
			tooltip:AddLine( format("|cffff8000In Bags|r |cffffffff%i|r", BankListStock[itemname]["bagged"]) );
		end
		if BankListStock[itemname]["farm"] ~= nil then
			tooltip:AddLine( format("|cffff8000Farm|r |cffffffff%i|r |cff808080(%s)|r", BankListStock[ itemname ]["farm"]["amount"], BankListStock[itemname]["farm"]["date"]) );
		end
	end
	tooltip:Show();
end


function BankGUI_OnHyperlinkEnter(_, _, linktext, mousebutton)
	if not BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] then return end
	local i, j = string.find(linktext, "|Hplayer");
	if i ~= nil then
		i = string.find(linktext, "[[]", j);
		i = i + 1;
		_, j = string.find(linktext, "[]]", i);
		j = j - 1;
		if string.sub(linktext, i, j) == bank_playername then return end
		if BankListFL[string.sub(linktext, i, j)] then
			GameTooltip:SetOwner(this, "ANCHOR_CURSOR");
			if BankListFL[string.sub(linktext, i, j)]["level"] ~= nil then
				GameTooltip:AddLine( format("|cffff8000Level|r |cffffffff%i|r", BankListFL[string.sub(linktext, i, j)]["level"]) );
			end
			if BankListFL[string.sub(linktext, i, j)]["class"] ~= nil then
				GameTooltip:AddLine( format("|cffff8000Class|r |cffffffff%s|r", BankListFL[string.sub(linktext, i, j)]["class"]) );
			end
			if BankListFL[string.sub(linktext, i, j)]["note"] ~= nil then
				GameTooltip:AddLine( format("|cffff8000Note|r |cffffffff%s|r", BankListFL[string.sub(linktext, i, j)]["note"]) );
			end
			GameTooltip:Show();
			return;
		end
		GameTooltip:Show();
	else
		local itemname, itemlink = GetItemInfo(linktext);
		if BankListStock[itemname] then
			GameTooltip:SetOwner(this, "ANCHOR_CURSOR");
			BankGUI:AddTooltip(GameTooltip, itemname);
			return;
		end
	end
end


function BankGUI_OnHyperlinkLeave()
	if not BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] then return end
	GameTooltip:Hide();
end


function BankGUI:Convert()
	local i, x, y, bankinfo = 1, 0, 0, { };
	if not BankListCurrency then BankListCurrency = {} end
	if not BankListCurrency[GetRealmName()] then BankListCurrency[GetRealmName()] = {} end
	if not BankListFriends then BankListFriends = {} end
	if not BankListFriends[GetRealmName()] then BankListFriends[GetRealmName()] = {} end
	if not BankListGlyphs then BankListGlyphs = {} end
	if not BankListGlyphs[GetRealmName()] then BankListGlyphs[GetRealmName()] = {} end
	if not BankListFarms then BankListFarms = {} end
	if not BankListFarms[GetRealmName()] then BankListFarms[GetRealmName()] = {} end
	while true do
	  for i = 1, table.getn(BankListItems[GetRealmName()]) do
		if BankListItems[GetRealmName()][i]["type"] == BANKGUI_TYPE_CURRENCY then
			bankinfo = {};
			bankinfo["name"] = BankListItems[GetRealmName()][i]["name"];
			bankinfo["item"] = BankListItems[GetRealmName()][i]["item"];
			bankinfo["amount"] = BankListItems[GetRealmName()][i]["amount"];
			table.insert(BankListCurrency[GetRealmName()], bankinfo);
			table.remove(BankListItems[GetRealmName()], i);
			break;
		end
		if BankListItems[GetRealmName()][i]["type"] == BANKGUI_TYPE_FRIENDS then
			bankinfo = {};
			x, y = string.find(BankListItems[GetRealmName()][i]["item"], " ");
			if x then
				y = ( x - 1 );
				x = 1;
				bankinfo["name"] = string.sub(BankListItems[GetRealmName()][i]["item"], x, y);
			else
				bankinfo["name"] = BankListItems[GetRealmName()][i]["item"];
			end
			bankinfo["level"] = 0;
			bankinfo["class"] = "Unknown";
			x, y = string.find(BankListItems[GetRealmName()][i]["item"], "|cffffff80");
			if x then
				x = y + 1;
				y = ( string.len(BankListItems[GetRealmName()][i]["item"]) - 2 );
				bankinfo["note"] = string.sub(BankListItems[GetRealmName()][i]["item"], x, y);
			end
			table.insert(BankListFriends[GetRealmName()], bankinfo);
			table.remove(BankListItems[GetRealmName()], i);
			break;
		end
		if BankListItems[GetRealmName()][i]["type"] == BANKGUI_TYPE_GLYPHS then
			bankinfo = {};
			bankinfo["name"] = BankListItems[GetRealmName()][i]["name"];
			bankinfo["spec"] = GetActiveTalentGroup(false,false);
			bankinfo["item"] = BankListItems[GetRealmName()][i]["item"];
			bankinfo["slot"] = tonumber( BankListItems[GetRealmName()][i]["bank"] );
			table.insert(BankListGlyphs[GetRealmName()], bankinfo);
			table.remove(BankListItems[GetRealmName()], i);
			break;
		end
		if BankListItems[GetRealmName()][i]["type"] == BANKGUI_TYPE_FARMS then
			bankinfo = {};
			bankinfo["name"] = BankListItems[GetRealmName()][i]["name"];
			bankinfo["item"] = BankListItems[GetRealmName()][i]["item"];
			bankinfo["amount"] = BankListItems[GetRealmName()][i]["amount"];
			bankinfo["date"] = BankListItems[GetRealmName()][i]["bank"];
			table.insert(BankListFarms[GetRealmName()], bankinfo);
			table.remove(BankListItems[GetRealmName()], i);
			break;
		end
	  end
	  i = i + 1;
	  if table.getn(BankListItems[GetRealmName()]) == 0 then return end
	  if i >= table.getn(BankListItems[GetRealmName()]) then return end
	end
end


function BankGUI:UpdateCurrency()
	if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPCURR] then return end
	local i, j, bank_cl_name, bank_cl_header, bank_cl_amount, bank_cl_already;
	local bankinfo_curr = {};
	for i = 1, GetCurrencyListSize() do
		bank_cl_name, bank_cl_header, _, _, _, bank_cl_amount = GetCurrencyListInfo(i);
		if bank_cl_name and not bank_cl_header then
			bank_cl_already = false;
			for j = 1, table.getn(BankListCurrency[GetRealmName()]) do
				if BankListCurrency[GetRealmName()][j]["item"] == nil then
					table.remove(BankListCurrency[GetRealmName()], j);
				end
				if j > table.getn(BankListCurrency[GetRealmName()]) then break end
				if BankListCurrency[GetRealmName()][j]["name"] == bank_playername and BankListCurrency[GetRealmName()][j]["item"] == bank_cl_name then
					bank_cl_already = true;
					BankListCurrency[GetRealmName()][j]["amount"] = bank_cl_amount;
					break;
				end
			end
			if not bank_cl_already then
				bankinfo_curr = {};
				bankinfo_curr["name"] = bank_playername;
				bankinfo_curr["item"] = bank_cl_name;
				bankinfo_curr["amount"] = bank_cl_amount;
				table.insert(BankListCurrency[GetRealmName()], bankinfo_curr);
			end
		end
	end
	for j = 1, table.getn(BankListCurrency[GetRealmName()]) do
		if BankListCurrency[GetRealmName()][j]["item"] == nil then
			table.remove(BankListCurrency[GetRealmName()], j);
		end
		if j > table.getn(BankListCurrency[GetRealmName()]) then break end
	end
	table.sort(BankListCurrency[GetRealmName()], function(a,b)
		return a["name"] < b["name"]
	end );
	table.sort(BankListCurrency[GetRealmName()], function(a,b)
		if a["name"] == b["name"] then return a["item"] < b["item"] else return a["name"] < b["name"] end
	end );
end


function BankGUI:UpdateFriends()
	if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPFRIEND] then return end
	ShowFriends();
	local bank_friend_name, bank_friend_level, bank_friend_class, bank_friend_connected, bank_friend_note;
	local i, j, bank_friend_already, bank_friend_connected = 0, 0, false, false;
	local bankinfo_friend = nil;
--[[
	for j = 1, table.getn(BankListFriends[GetRealmName()]) do
		bank_friend_name = BankListFriends[GetRealmName()][j]["name"];
		BankListFriends[GetRealmName()][ bank_friend_name ] = {};
		if BankListFriends[GetRealmName()][j]["level"] then
			BankListFriends[GetRealmName()][ bank_friend_name ]["level"] = BankListFriends[GetRealmName()][j]["level"]
		end
		if BankListFriends[GetRealmName()][j]["class"] then
			BankListFriends[GetRealmName()][ bank_friend_name ]["class"] = BankListFriends[GetRealmName()][j]["class"]
		end
		if BankListFriends[GetRealmName()][j]["note"] then
			BankListFriends[GetRealmName()][ bank_friend_name ]["note"] = BankListFriends[GetRealmName()][j]["note"]
		end
	end
--]]
	for i = 1, GetNumFriends() do
		bank_friend_name, bank_friend_level, bank_friend_class, _, bank_friend_connected, _, bank_friend_note = GetFriendInfo(i);
		if bank_friend_name then
--[[
			if not BankListFriends[GetRealmName()][ bank_friend_name ] then
				BankListFriends[GetRealmName()][ bank_friend_name ] = {};
				if bank_friend_connected and bank_friend_level > 0 then
					BankListFriends[GetRealmName()][ bank_friend_name ]["level"] = bank_friend_level;
					BankListFriends[GetRealmName()][ bank_friend_name ]["class"] = bank_friend_class;
				else
					BankListFriends[GetRealmName()][ bank_friend_name ]["level"] = 0;
					BankListFriends[GetRealmName()][ bank_friend_name ]["class"] = "Unknown";
				end
				if bank_friend_note ~= nil and bank_friend_note ~= "" then
					BankListFriends[GetRealmName()][ bank_friend_name ]["note"] = bank_friend_note;
				end
			end
--]]
			bank_friend_already = false;
			for j = 1, table.getn(BankListFriends[GetRealmName()]) do
				if BankListFriends[GetRealmName()][j]["name"] == nil then
					table.remove(BankListFriends[GetRealmName()], j);
				end
				if j > table.getn(BankListFriends[GetRealmName()]) then break end
				if BankListFriends[GetRealmName()][j]["name"] == bank_friend_name then
					bank_friend_already = true;
					if bank_friend_connected and bank_friend_level > 0 then
						BankListFriends[GetRealmName()][j]["level"] = bank_friend_level;
						BankListFriends[GetRealmName()][j]["class"] = bank_friend_class;
					else
						BankListFriends[GetRealmName()][j]["level"] = 0;
						BankListFriends[GetRealmName()][j]["class"] = "Unknown";
					end
					if bank_friend_note ~= nil and bank_friend_note ~= "" then
						BankListFriends[GetRealmName()][j]["note"] = bank_friend_note;
					end
				end
			end
			if not bank_friend_already then
				bankinfo_friend = {};
				bankinfo_friend["name"] = bank_friend_name;
				bankinfo_friend["level"] = bank_friend_level;
				bankinfo_friend["class"] = bank_friend_class;
				bankinfo_friend["note"] = bank_friend_note;
				table.insert(BankListFriends[GetRealmName()], bankinfo_friend);
			end
		end
	end
	if BankListFriends ~= nil and BankListFriends[GetRealmName()] ~= nil then
		table.sort(BankListFriends[GetRealmName()], function(a,b) return (a["name"] < b["name"]) end );
		for i = 1, table.getn(BankListFriends[GetRealmName()]) do
			BankListFL[ BankListFriends[GetRealmName()][i]["name"] ] = {};
			BankListFL[ BankListFriends[GetRealmName()][i]["name"] ]["level"] = BankListFriends[GetRealmName()][i]["level"];
			BankListFL[ BankListFriends[GetRealmName()][i]["name"] ]["class"] = BankListFriends[GetRealmName()][i]["class"];
			BankListFL[ BankListFriends[GetRealmName()][i]["name"] ]["note"] = BankListFriends[GetRealmName()][i]["note"];
		end
	end
end


function BankGUI:UpdateGlyphs()
	if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPGLYPS] then return end
	local glyph_enabled, glyph_SpellID, glyph_itemlink, glyph_already;
	local bankinfo_glyph = {};
	for i = 1, GetNumGlyphSockets() do
		glyph_SpellID, glyph_itemlink, glyph_already = nil, nil, false;
		glyph_enabled, _, glyph_SpellID, _ = GetGlyphSocketInfo(i);
		if ( glyph_enabled and glyph_SpellID ~= nil ) then
			glyph_itemlink = GetGlyphLink(i);
			if ( glyph_itemlink ) then
				for j = 1, table.getn(BankListGlyphs[GetRealmName()]) do
					if BankListGlyphs[GetRealmName()][j]["name"] == nil or BankListGlyphs[GetRealmName()][j]["item"] == nil then
						table.remove(BankListGlyphs[GetRealmName()], j);
					end
					if j > table.getn(BankListGlyphs[GetRealmName()]) then break end
					if BankListGlyphs[GetRealmName()][j]["spec"] == nil then BankListGlyphs[GetRealmName()][j]["spec"] = GetActiveTalentGroup(false,false) end
					if BankListGlyphs[GetRealmName()][j]["name"] == bank_playername and BankListGlyphs[GetRealmName()][j]["spec"] == GetActiveTalentGroup(false,false) and BankListGlyphs[GetRealmName()][j]["slot"] == i then
						glyph_already = true;
						BankListGlyphs[GetRealmName()][j]["item"] = glyph_itemlink;
						break;
					end
				end
				if not glyph_already then
					bankinfo_glyph = {};
					bankinfo_glyph["name"] = bank_playername;
					bankinfo_glyph["spec"] = GetActiveTalentGroup(false,false);
					bankinfo_glyph["item"] = glyph_itemlink;
					bankinfo_glyph["slot"] = i;
					table.insert(BankListGlyphs[GetRealmName()], bankinfo_glyph);
				end
			else
				for j = 1, table.getn(BankListGlyphs[GetRealmName()]) do
					if BankListGlyphs[GetRealmName()][j]["name"] == bank_playername and BankListGlyphs[GetRealmName()][j]["spec"] == GetActiveTalentGroup(false,false) and BankListGlyphs[GetRealmName()][j]["slot"] == i then
						table.remove(BankListItems[GetRealmName()], j);
						break;
					end
				end
			end
		end
	end
	table.sort(BankListGlyphs[GetRealmName()], function(a,b)
		return a["name"] < b["name"]
	end );
	table.sort(BankListGlyphs[GetRealmName()], function(a,b)
		if a["name"] == b["name"] then
			return a["spec"] < b["spec"]
		else
			return a["name"] < b["name"]
		end
	end );
	table.sort(BankListGlyphs[GetRealmName()], function(a,b)
		if a["name"] == b["name"] then
			if a["spec"] == b["spec"] then
				return a["slot"] < b["slot"]
			else
				return a["spec"] < b["spec"]
			end
		else
			return a["name"] < b["name"]
		end
	end );
end


function BankGUI:UpdateStock()
	if not BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] then return end
	local i, j, itemname, itemlink, itemrarity, itemcount, itemstack;
	BankListStock = {};
	for i = 1, table.getn(BankListItems[GetRealmName()]) do
		if BankGUI:IsValidType(BankListItems[GetRealmName()][i]) then
			itemname, _, _, _, _, _, _, itemstack = GetItemInfo(BankListItems[GetRealmName()][i]["item"]);
			if itemname and itemstack > 1 then
				if not BankListStock[ itemname ] then BankListStock[ itemname ] = {} end
				if not BankListStock[ itemname ]["stock"] then BankListStock[ itemname ]["stock"] = 0 end
				if not BankListStock[ itemname ]["self"] then BankListStock[ itemname ]["self"] = 0 end
				BankListStock[ itemname ]["stock"] = BankListStock[ itemname ]["stock"] + BankListItems[GetRealmName()][i]["amount"];
				if BankListItems[GetRealmName()][i]["name"] == bank_playername then BankListStock[ itemname ]["self"] = BankListStock[ itemname ]["self"] + BankListItems[GetRealmName()][i]["amount"] end
			end
		end
	end
	for j = -2, -2 do
		for i = 1, GetContainerNumSlots(j) do
			itemlink = GetContainerItemLink(j, i);
			if itemlink then
				_, itemcount = GetContainerItemInfo(j, i);
				itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink );
				if ( itemname ~= nil and itemstack > 1 ) and ( itemrarity ~= nil and itemrarity > 0 ) then
					if not BankListStock[ itemname ] then BankListStock[ itemname ] = {} end
					if not BankListStock[ itemname ]["bagged"] then BankListStock[ itemname ]["bagged"] = 0 end
					BankListStock[ itemname ]["bagged"] = BankListStock[ itemname ]["bagged"] + itemcount;
				end
			end
		end
	end
	for j = 0, 4 do
		for i = 1, GetContainerNumSlots(j) do
			itemlink = GetContainerItemLink(j, i);
			if itemlink then
				_, itemcount = GetContainerItemInfo(j, i);
				itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink );
				if ( itemname ~= nil and itemstack > 1 ) and ( itemrarity ~= nil and itemrarity > 0 ) then
					if not BankListStock[ itemname ] then BankListStock[ itemname ] = {} end
					if not BankListStock[ itemname ]["bagged"] then BankListStock[ itemname ]["bagged"] = 0 end
					BankListStock[ itemname ]["bagged"] = BankListStock[ itemname ]["bagged"] + itemcount;
				end
			end
		end
	end
	for i = 1, table.getn(BankListFarms[GetRealmName()]) do
		itemname, _, _, _, _, _, _, itemstack = GetItemInfo(BankListFarms[GetRealmName()][i]["item"]);
		if itemname == nil and BankListFarms[GetRealmName()][i]["item"] ~= nil then
			itemname = BankListFarms[GetRealmName()][i]["item"];
			itemstack = 20;
		end
		if itemname and itemstack > 1 then
			if not BankListStock[ itemname ] then BankListStock[ itemname ] = {} end
			if not BankListStock[ itemname ]["farm"] then BankListStock[ itemname ]["farm"] = {} end
			if not BankListStock[ itemname ]["farm"]["amount"] then BankListStock[ itemname ]["farm"]["amount"] = 0 end
			if not BankListStock[ itemname ]["farm"]["date"] then BankListStock[ itemname ]["farm"]["date"] = BankListFarms[GetRealmName()][i]["date"] end
			BankListStock[ itemname ]["farm"]["amount"] = BankListStock[ itemname ]["farm"]["amount"] + BankListFarms[GetRealmName()][i]["amount"];
			if BankListFarms[GetRealmName()][i]["date"] < BankListStock[ itemname ]["farm"]["date"] then BankListStock[ itemname ]["farm"]["date"] = BankListFarms[GetRealmName()][i]["date"] end
		end
	end
end


-- Function to handle events
function BankGUI:HandleEvent(event)
	if (event == "VARIABLES_LOADED") then
		local playerinfo = { ["name"] = "", ["money"] = 0 };
		local optionsinfo = { ["detach"] = false, ["guild_checked"] = false, ["guild_name"] = nil, ["player_name"] = nil, ["player_type"] = 1 };
		local i, element_exists, subarray = 0, false;
		if not BankListOptions then BankListOptions = {} end
		if not BankListOptions[GetRealmName()] then BankListOptions[GetRealmName()] = {} end
		if not BankListOptions[GetRealmName()][1] then
			table.insert( BankListOptions[GetRealmName()], optionsinfo );
		end

		if BankListOptions[GetRealmName()][1]["detach"] == nil then BankListOptions[GetRealmName()][1]["detach"] = false end
		if BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] == nil then BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] = true end
		for subarray in pairs(BANKGUI_OPTIONS_MENU) do
			if not BankListOptions[GetRealmName()][1][ subarray ] then BankListOptions[GetRealmName()][1][ subarray ] = {} end
			for i = 1, table.getn(BANKGUI_OPTIONS_MENU[ subarray ]) do
				if BankListOptions[GetRealmName()][1][subarray][ BANKGUI_OPTIONS_MENU[subarray][i] ] == nil then BankListOptions[GetRealmName()][1][subarray][ BANKGUI_OPTIONS_MENU[subarray][i] ] = true end
			end
		end

		TypesIndex = BankListOptions[GetRealmName()][1]["player_type"];

		if not BankListGuildInfo then BankListGuildInfo = {} end
		if not BankListGuildInfo[GetRealmName()] then BankListGuildInfo[GetRealmName()] = {} end

		if not BankListGuildItems then BankListGuildItems = {} end
		if not BankListGuildItems[GetRealmName()] then BankListGuildItems[GetRealmName()] = {} end

		if BankListFriends == nil then BankListFriends = {} end
		if BankListFriends[GetRealmName()] == nil then BankListFriends[GetRealmName()] = {} end

		bank_playername = UnitName("player");
		bank_guildname = GetGuildInfo("player");

		playerinfo["name"] = bank_playername;
		playerinfo["money"] = GetMoney();
		if not BankFilter then BankFilter = {} end
		if not BankFilter[GetRealmName()] then BankFilter[GetRealmName()] = {} end
		if not BankListItems then BankListItems = {} end
		if not BankListItems[GetRealmName()] then BankListItems[GetRealmName()] = {} end
		if not BankListPlayers then BankListPlayers = {} end
		if not BankListPlayers[GetRealmName()] then BankListPlayers[GetRealmName()] = {} end
		if bank_playername then
			element_exists = false;
			for i = 1, table.getn(BankListPlayers[GetRealmName()]) do
				if BankListPlayers[GetRealmName()][i]["name"] == bank_playername then
					BankListPlayers[GetRealmName()][i]["money"] = GetMoney();
					element_exists = true;
				end
			end
			if not element_exists then
				table.insert( BankListPlayers[GetRealmName()], playerinfo );
				table.sort( BankListPlayers[GetRealmName()], function(a,b) return a["name"] < b["name"] end );
			end
			local wispinfo = { ["name"] = UnitName("player") };
			table.insert(Wisp_Data, wispinfo);
		end

		if not BankListOptions[GetRealmName()][1]["RunOnceConvert"] then
			BankGUI:Convert();
			BankListOptions[GetRealmName()][1]["RunOnceConvert"] = true;
		end

		BankGUI:InsertUI();
		if BankListOptions[GetRealmName()][1]["detach"] and BankListOptions[GetRealmName()][1]["pos"] then
			BankGUIFrame:SetPoint(BankListOptions[GetRealmName()][1]["pos"]["point"], "UIParent", BankListOptions[GetRealmName()][1]["pos"]["relativePoint"], BankListOptions[GetRealmName()][1]["pos"]["xOfs"], BankListOptions[GetRealmName()][1]["pos"]["yOfs"]);
		end

		if ChatFrame1 then
			ChatFrame1:HookScript("OnHyperlinkClick", BankGUI_OnHyperlinkClick);
			ChatFrame1:HookScript("OnHyperlinkEnter", BankGUI_OnHyperlinkEnter);
			ChatFrame1:HookScript("OnHyperlinkLeave", BankGUI_OnHyperlinkLeave);
		end
		if ChatFrame2 then
			ChatFrame2:HookScript("OnHyperlinkClick", BankGUI_OnHyperlinkClick);
			ChatFrame2:HookScript("OnHyperlinkEnter", BankGUI_OnHyperlinkEnter);
			ChatFrame2:HookScript("OnHyperlinkLeave", BankGUI_OnHyperlinkLeave);
		end
		if ChatFrame3 then
			ChatFrame3:HookScript("OnHyperlinkClick", BankGUI_OnHyperlinkClick);
			ChatFrame3:HookScript("OnHyperlinkEnter", BankGUI_OnHyperlinkEnter);
			ChatFrame3:HookScript("OnHyperlinkLeave", BankGUI_OnHyperlinkLeave);
		end
		if ChatFrame4 then
			ChatFrame4:HookScript("OnHyperlinkClick", BankGUI_OnHyperlinkClick);
			ChatFrame4:HookScript("OnHyperlinkEnter", BankGUI_OnHyperlinkEnter);
			ChatFrame4:HookScript("OnHyperlinkLeave", BankGUI_OnHyperlinkLeave);
		end
		if ChatFrame5 then
			ChatFrame5:HookScript("OnHyperlinkClick", BankGUI_OnHyperlinkClick);
			ChatFrame5:HookScript("OnHyperlinkEnter", BankGUI_OnHyperlinkEnter);
			ChatFrame5:HookScript("OnHyperlinkLeave", BankGUI_OnHyperlinkLeave);
		end
		if GameTooltip then
			GameTooltip:HookScript("OnTooltipSetItem",
			function(tooltip, ...)
				if not BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] then return end
				local itemname, itemlink = tooltip:GetItem();
				if BankListStock[itemname] then
					tooltip:AddLine( " " );
					BankGUI:AddTooltip(tooltip, itemname);
				end
				if IsShiftKeyDown() then
					local itemlevel, itemminlevel;
					_, _, _, itemlevel, itemminlevel = GetItemInfo(itemlink);
					tooltip:AddLine( " " );
					tooltip:AddLine( format("|cffff8000MinLvl / Lvl|r |cffffffff%i / %i|r", itemminlevel, itemlevel) );
				end
			end );
		end
		return;
	end

	if (event == "PLAYER_LOGIN") then
		local playerinfo = {["name"] = "", ["money"] = 0, };
		local i, j, element_exists = 0, 0, false;
		bank_playername = UnitName("player");
		if bank_playername then
			playerinfo["money"] = GetMoney();
			element_exists = false;
			for i = 1, table.getn(BankListPlayers[GetRealmName()]) do
				if BankListPlayers[GetRealmName()][i]["name"]==bank_playername then
					BankListPlayers[GetRealmName()][i]["money"] = GetMoney();
					element_exists = true;
				end
			end
			if not element_exists then
				table.insert( BankListPlayers[GetRealmName()], playerinfo );
				BankListPlayers[GetRealmName()][table.getn(BankListPlayers[GetRealmName()])]["money"] = GetMoney();
				table.sort( BankListPlayers[GetRealmName()], function(a,b) return a["name"] < b["name"] end );
			end
		end

		BankGUI:UpdateFriends();
		BankGUI:UpdateGlyphs();
		BankGUI:UpdateStock();

		BankGUIDetachCheckButton:SetChecked(BankListOptions[GetRealmName()][1]["detach"]);

		BankGUIGuildCheckButton:SetChecked(BankListOptions[GetRealmName()][1]["guild_checked"]);
		BankGUIGuildCheckButton_OnClick(BankGUIGuildCheckButton);

		BankGUI:UpdateFilter(nil);

		return;
	end

	if (event == "PLAYER_GUILD_UPDATE") then
		local guildinfo = {["name"] = "", ["money"] = 0, };
		local i, element_exists = 0, false;
		bank_guildname = GetGuildInfo("player");
		if bank_guildname then
			if not BankListGuildItems[GetRealmName()][bank_guildname] then BankListGuildItems[GetRealmName()][bank_guildname] = {} end
			guildinfo["name"] = bank_guildname;
			guildinfo["money"] = GetGuildBankMoney();
			for i = 1, table.getn(BankListGuildInfo[GetRealmName()]) do
				if BankListGuildInfo[GetRealmName()][i]["name"] == bank_guildname then
					if guildinfo["money"] ~= 0 then BankListGuildInfo[GetRealmName()][i]["money"] = guildinfo["money"] end
					element_exists = true;
				end
			end
			if not element_exists then table.insert(BankListGuildInfo[GetRealmName()], guildinfo) end
			BankGUIGuildCheckButton:SetChecked(BankListOptions[GetRealmName()][1]["guild_checked"]);
			BankGUIGuildCheckButton_OnClick(BankGUIGuildCheckButton);
			BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		end
		return;
	end

	if (event == "CURRENCY_DISPLAY_UPDATE") then
		BankGUI:UpdateCurrency();
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		return;
	end

	if (event == "ACTIVE_TALENT_GROUP_CHANGED") then
		BankGUI:UpdateGlyphs();
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		return;
	end

	if (event == "PLAYER_MONEY") then
		local bank_gold_tot = 0.0;
		bank_playername = UnitName("player");
		bank_guildname = GetGuildInfo("player");
		for i = 1, table.getn(BankListPlayers[GetRealmName()]) do
			if BankListPlayers[GetRealmName()][i]["name"]==bank_playername then
				BankListPlayers[GetRealmName()][i]["money"] = GetMoney();
			end
			bank_gold_tot = bank_gold_tot + (BankListPlayers[GetRealmName()][i]["money"]/10000);
		end
		if not BankListOptions[GetRealmName()][1]["guild_checked"] then BankGUITotalGold:SetText( format(BANKGUI_GOLD_BANK,bank_gold_tot) ) end
		return;
	end

	if (event == "CHAT_MSG_WHISPER") then
		local wispinfo = { ["name"] = arg2 };
		local i, element_exists = 1, false;
		for i = 1, table.getn(Wisp_Data) do
			if Wisp_Data[i]["name"] == arg2 then
				element_exists = true;
				break;
			end
		end
		if not element_exists then
			table.insert(Wisp_Data, wispinfo);
			table.sort(Wisp_Data, function(a,b) return a["name"] < b["name"] end );
		end
		if ( string.sub(arg1, 1, 1) == "!" and string.len(arg1) > 1 ) then
			local craftable = string.lower( string.sub(arg1, 2) );
			local j, subarray = 0;
			for subarray in pairs(BankListStock) do
				if ( string.find(string.lower(subarray), craftable) ~= nil ) then
					if j < 10 then SendChatMessage( format("[%s]x%i", subarray, BankListStock[subarray]["stock"]), "WHISPER", nil, arg2)
					else
						SendChatMessage("--- Too many items found. Listing is stopped. ---", "WHISPER", nil, arg2);
						break;
					end
					j = j + 1;
				end
			end
		end
		return;
	end

	if (event == "CHAT_MSG_SYSTEM") then
		if arg1 ~= nil then
			local bank_friend_name, bank_friend_level, bank_friend_class, bank_friend_note, bank_fl_name;
			local i, j = string.find(arg1, "|Hplayer");
			if i ~= nil then
				i = string.find(arg1, "[[]", j);
				i = i + 1;
				_, j = string.find(arg1, "[]]", i);
				j = j - 1;
				if string.sub(arg1, i, j) == bank_playername then return end
				bank_fl_name = string.sub(arg1, i, j);
				if BankListFL[bank_fl_name] ~= nil then
					ShowFriends();
					for i = 1, GetNumFriends() do
						bank_friend_name, bank_friend_level, bank_friend_class, _, _, _, bank_friend_note = GetFriendInfo(i);
						if bank_friend_name == bank_fl_name then
							for j = 1, table.getn(BankListFriends[GetRealmName()]) do
								if BankListFriends[GetRealmName()][j]["name"] == bank_fl_name then
									if BankListFriends[GetRealmName()][j]["level"] ~= bank_friend_level then
										BankListFriends[GetRealmName()][j]["level"] = bank_friend_level;
										BankListFL[bank_fl_name]["level"] = bank_friend_level;
									end
									if BankListFriends[GetRealmName()][j]["class"] ~= bank_friend_class then
										BankListFriends[GetRealmName()][j]["class"] = bank_friend_class;
										BankListFL[bank_fl_name]["class"] = bank_friend_class;
									end
									if BankListFriends[GetRealmName()][j]["note"] ~= nil and BankListFriends[GetRealmName()][i]["note"] ~= bank_friend_note then
										BankListFriends[GetRealmName()][j]["note"] = bank_friend_note;
										BankListFL[bank_fl_name]["note"] = bank_friend_note;
									end
								end
							end
							return;
						end
					end
				end
			end
		end
		return;
	end

	if (event == "BAG_UPDATE") then
		if bank_frame_opened then return end
		if not BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] then return end
		if arg1 == -4 then return end
		local subarray, itemlink, itemname, itemcount, itemstack;
		for subarray in pairs(BankListStock) do
			BankListStock[ subarray ]["bagged"] = 0;
		end
		for j = -2, -2 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i);
				if itemlink then
					_, itemcount = GetContainerItemInfo(j, i);
					itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink );
					if ( itemname ~= nil and itemstack > 1 ) and ( itemrarity ~= nil and itemrarity > 0 ) then
						if not BankListStock[ itemname ] then
							BankListStock[ itemname ] = {};
							BankListStock[ itemname ]["bagged"] = 0;
						end
						BankListStock[ itemname ]["bagged"] = BankListStock[ itemname ]["bagged"] + itemcount;
					end
				end
			end
		end
		for j = 0, 4 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i);
				if itemlink then
					_, itemcount = GetContainerItemInfo(j, i);
					itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink );
					if ( itemname ~= nil and itemstack > 1 ) and ( itemrarity ~= nil and itemrarity > 0 ) then
						if not BankListStock[ itemname ] then
							BankListStock[ itemname ] = {};
							BankListStock[ itemname ]["bagged"] = 0;
						end
						BankListStock[ itemname ]["bagged"] = BankListStock[ itemname ]["bagged"] + itemcount;
					end
				end
			end
		end
		for subarray in pairs(BankListStock) do
			if BankListStock[ subarray ]["bagged"] and BankListStock[ subarray ]["bagged"] <= 0 then
				BankListStock[ subarray ]["bagged"] = nil;
			end
			if BankListStock[ subarray ]["stock"] and BankListStock[ subarray ]["stock"] <= 0 then
				BankListStock[ subarray ]["stock"] = nil;
			end
			if BankListStock[ subarray ]["bagged"] == nil and BankListStock[ subarray ]["stock"] == nil and BankListStock[ subarray ]["farm"] == nil then BankListStock[ subarray ] = nil end
		end
		return;
	end

	if ( event == "BANKFRAME_OPENED" ) then
		bank_frame_opened = true;
		if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPITEMS] then return end
		local i, j, k, itemlink, itemcount;
		local bank_keepremoving = true;
		while bank_keepremoving do
			k = BankGUI:GetBankItemIndexByName(bank_playername);
			if k == 0 then bank_keepremoving = false
			else
				table.remove( BankListItems[GetRealmName()], k )
			end
		end
		k = 1;
		for j = -2, 11 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j,i);
				_, itemcount = GetContainerItemInfo(j,i);
				if itemlink then BankGUI:AddItem(itemlink, itemcount, true, nil, false, j) end
			end
		end
		for i = 0, 19 do
			itemlink = GetInventoryItemLink("player", i);
			if itemlink then BankGUI:AddItem(itemlink, 1, true, "-3", false, nil) end
		end
		table.sort( BankListItems[GetRealmName()], function(a,b)
			local i = string.find(a["item"], "|h")
			local j = string.find(b["item"], "|h")
			if i == nil then i = 1 end
			if j == nil then j = 1 end
			if a["name"] == b["name"] then return string.sub(a["item"], i) < string.sub(b["item"], j)
			else return a["name"] < b["name"] end
		end );
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		return;
	end

	if ( event == "BANKFRAME_CLOSED" ) then
		BankGUI:UpdateStock();
		bank_frame_opened = false;
		return;
	end

	if ( event == "TRADE_SKILL_SHOW" ) then
		local islinked, islinkedname = IsTradeSkillLinked();
		if islinked and arg2 then
			if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPPROFS] then return end
			local tradeinfo, tradetitlestr, i, j = { }, nil, string.find(arg2,"|Htrade");
			if i ~= nil then
				j = string.find(arg2, "|h|r");
				i = string.find(arg2, "|h", (i+7));
				tradetitlestr = string.sub(arg2, (i+3), (j-2));
				if tradetitlestr == nil then return end
			end
			for i = 1, table.getn(BankListItems[GetRealmName()]) do
				if BankListItems[GetRealmName()][i]["type"] == "-4" and BankListItems[GetRealmName()][i]["name"] == islinkedname and string.find(BankListItems[GetRealmName()][i]["item"],tradetitlestr) ~= nil then
					BankListItems[GetRealmName()][i]["item"] = arg2;
					BankListItems[GetRealmName()][i]["amount"] = date("%d/%m/%y %H:%M");
					return;
				end
			end
			tradeinfo["type"] = "-4";
			tradeinfo["name"] = islinkedname;
			tradeinfo["amount"] = date("%d/%m/%y %H:%M");
			tradeinfo["item"] = arg2;
			tradeinfo["bank"] = false;
			table.insert(BankListItems[GetRealmName()], tradeinfo);
			table.sort( BankListItems[GetRealmName()], function(a,b)
				local i = string.find(a["item"],"|h")
				local j = string.find(b["item"],"|h")
				if i == nil then i = 1 end
				if j == nil then j = 1 end
				if a["name"] == b["name"] then return string.sub(a["item"],i) < string.sub(b["item"],j)
				else return a["name"] < b["name"] end
				end
			);
			BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
			BankGUI:UpdateUI();
			return;
		end
		if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPTRADE] then return end
		local i = 0;
		local sName, sType, itemlink;
		for i = 1, GetNumTradeSkills() do
			sName, sType = GetTradeSkillInfo(i);
			if ( sName and sType ~= "header" ) then
				itemlink = GetTradeSkillRecipeLink(i);
				if not BankGUI:GetSkillItemByName(itemlink, sType) then BankGUI:AddItem(itemlink, 1, false, sType, false, nil) end
			end
		end
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		return;
	end

	if ( event == "GUILDBANKFRAME_OPENED" ) then
		if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPGUILD] then return end
		local i, j, k, itemlink, itemcount;
		local guildinfo = {["name"] = "", ["money"] = 0 };
		local element_exists = false;
		bank_guildname = GetGuildInfo("player");
		if not BankListGuildItems then BankListGuildItems = {} end
		if not BankListGuildItems[GetRealmName()] then BankListGuildItems[GetRealmName()] = {} end
		if bank_guildname then
			guildinfo["name"] = bank_guildname;
			guildinfo["money"] = GetGuildBankMoney();
			if not BankListGuildInfo then BankListGuildInfo = {} end
			if not BankListGuildInfo[GetRealmName()] then BankListGuildInfo[GetRealmName()] = {} end
			for i = 1, table.getn(BankListGuildInfo[GetRealmName()]) do
				if BankListGuildInfo[GetRealmName()][i]["name"] == bank_guildname then
					element_exists = true;
					BankListGuildInfo[GetRealmName()][i]["money"] = guildinfo["money"];
				end
			end
			if not element_exists then table.insert(BankListGuildInfo[GetRealmName()], guildinfo) end
		end
		BankListGuildItems[GetRealmName()][bank_guildname] = {};
		for j = 1, GetNumGuildBankTabs() do
			QueryGuildBankTab(j);
			for i = 1, 98 do
				itemlink = GetGuildBankItemLink(j,i);
				_, itemcount = GetGuildBankItemInfo(j,i);
				if itemlink then BankGUI:AddItem(itemlink, itemcount, true, nil, true, nil) end
			end
		end
		table.sort( BankListGuildItems[GetRealmName()][bank_guildname], function(a,b)
			local i = string.find(a["item"],"|h")
			local j = string.find(b["item"],"|h")
			return string.sub(a["item"],i) < string.sub(b["item"],j)
			end
		);
		BankGUIGuildCheckButton_OnClick(BankGUIGuildCheckButton);
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		return;
	end
end


function BankGUI:Bank_SlashCommandHandler(msg)
	if msg == nil or msg == "" then
		BankGUI:ToggleTab()
	elseif msg == "help" or msg == "?" then
		local i;
		bank_chat:AddMessage(" ");
		for i = 1, table.getn(BANKGUI_HELP) do
			bank_chat:AddMessage(BANKGUI_HELP[i][1], BANKGUI_HELP[i][2], BANKGUI_HELP[i][3], BANKGUI_HELP[i][4]);
		end
	elseif msg == "update" then
		BankGUI:UpdateCurrency();
		BankGUI:UpdateFriends();
		BankGUI:UpdateGlyphs();
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		BankGUI:UpdateUI();
	elseif msg == "detach" then
		BankGUIDetachCheckButton:SetChecked(true);
		BankGUIDetachCheckButton_OnClick();
	elseif msg == "attach" then
		BankGUIDetachCheckButton:SetChecked(false);
		BankGUIDetachCheckButton_OnClick();
	elseif string.find(msg, "|Hitem") then
		msg = GetItemInfo(msg);
		BankGUIFilterTextBox:SetText(msg);
		BankGUI:ToggleTab();
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
	else
		BankGUIFilterTextBox:SetText(msg);
		BankGUI:ToggleTab();
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
	end
end
