function BankGUI:AddItem(item, amount, bank, type, guild, bagid)
	local bankuiinfo;
	-- handle item
	if (item == nil) then return end
	-- handle amount
	if (amount == nil) then amount = 1 end
	-- handle bank/skill item
	if (bank == nil) then bank = true end
	if (type == nil and bagid ~= nil) then type = "" ..bagid end

	if (guild == nil) then guild = false end

	if guild then
		bankuiinfo = {["item"] = item, ["amount"] = amount};
		table.insert(BankListGuildItems[GetRealmName()][bank_guildname], bankuiinfo);
	else
		bankuiinfo = {["name"] = bank_playername, ["item"] = item, ["amount"] = amount, ["bank"] = bank, ["type"] = type};
		table.insert(BankListItems[GetRealmName()], bankuiinfo);
	end
	-- self:UpdateUI();
end


function BankGUI:GetNumGuilds()
	if not BankListGuildInfo then return 0 end
	if not BankListGuildInfo[GetRealmName()] then return 0 end
	return table.getn(BankListGuildInfo[GetRealmName()]);
end


function BankGUI:GetGuild(index)
	if not BankListGuildInfo[GetRealmName()] then return ""
	elseif BankListGuildInfo[GetRealmName()][index] then return BankListGuildInfo[GetRealmName()][index]["name"]
	else return "" end
end


-- Returns the number of players in list
function BankGUI:GetNumItems()
	if BankFilter[GetRealmName()] then return table.getn(BankFilter[GetRealmName()]) else return 0 end
end


function BankGUI:GetBankItemIndexByName(name)
	local i;
	for i = 1, table.getn(BankListItems[GetRealmName()]) do
		if ( BankListItems[GetRealmName()][i]["name"] == name and Item_NoDelete[BankListItems[GetRealmName()][i]["type"]] == nil ) then return i end
	end
	return 0
end


function BankGUI:GetSkillItemByName(item, type)
	local i;
	for i = 1, table.getn(BankListItems[GetRealmName()]) do
		if BankListItems[GetRealmName()][i]["bank"] == false and BankListItems[GetRealmName()][i]["item"] == item then
			if type ~= "header" then BankListItems[GetRealmName()][i]["type"] = type end
			if string.find( BankListItems[GetRealmName()][i]["name"], bank_playername ) == nil then
				BankListItems[GetRealmName()][i]["name"] = BankListItems[GetRealmName()][i]["name"] .."," ..bank_playername;
			end
			return true;
		 end
	end
	return false;
end


-- Returns the player object given by index
function BankGUI:GetItemByIndex(index)

	if (index < 1 or index > self:GetNumItems()) then
		return nil
	end

	return BankFilter[GetRealmName()][index];

end
